import React from 'react';
export * from './CardHeader';
export * from './CardFooter';
export * from './CardTabs';
declare type BaseElement = HTMLDivElement;
declare type BaseProps = React.HTMLAttributes<BaseElement>;
export declare const CardPlainContent: import("styled-components").StyledComponent<"div", import("styled-components").DefaultTheme, {}, never>;
export declare const CardContent: import("styled-components").StyledComponent<"div", import("styled-components").DefaultTheme, {}, never>;
export declare type CardWidthType = 'small' | 'medium' | 'full';
export interface CardProps extends BaseProps {
    /**
     * `class` to be passed to the component.
     */
    readonly className?: BaseProps['className'];
    /**
     * The width of the card, one of `'small'`, `'medium'` or `'full'`.
     *
     * Default: `'full'`
     */
    readonly width?: CardWidthType;
    /**
     * Gives border-radius if it is `false`.
     *
     * Default: `true`.
     */
    readonly square?: boolean;
}
export declare const Card: React.FC<CardProps>;
export declare const PanelCard: React.FC<CardProps>;
