import React from 'react';
import { IconType } from '../Icon';
declare type BaseElement = HTMLDivElement;
declare type BaseProps = React.HTMLAttributes<BaseElement>;
interface NoteProps extends BaseProps {
    /**
     * `class` to be passed to the component.
     */
    readonly className?: BaseProps['className'];
    /**
     * Used to input text.
     */
    readonly text: string;
    /**
     * The icon element.
     */
    readonly icon: IconType;
}
export declare const Note: React.FunctionComponent<NoteProps>;
export {};
