import React from 'react';
declare type BaseElement = HTMLDivElement;
declare type BaseProps = React.HTMLAttributes<BaseElement>;
interface ProgressProps extends BaseProps {
    /**
     * `class` to be passed to the component.
     */
    readonly className?: BaseProps['className'];
    /**
     * Used to indicate the percentage value of the indicator.
     * Value should between 0 and 1.
     */
    readonly value: number;
    /**
     * A string used to tell the user information regarding the progress value.
     */
    readonly label: string;
}
export declare const Progress: React.FC<ProgressProps>;
export {};
