"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Progress = void 0;

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _Typography = require("../Typography");

var _designparams = require("../designparams");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var ProgressContainer = _styledComponents.default.div.withConfig({
  displayName: "Progress__ProgressContainer",
  componentId: "o1pri3-0"
})(["display:flex;align-items:center;width:100%;"]);

var ProgressIndicator = _styledComponents.default.div.withConfig({
  displayName: "Progress__ProgressIndicator",
  componentId: "o1pri3-1"
})(["position:relative;background-color:", ";border-radius:", ";height:5px;flex-grow:1;overflow:hidden;"], (_ref) => {
  var {
    theme
  } = _ref;
  return theme.color.element12();
}, _designparams.shape.radius.medium);

var ProgressMeter = _styledComponents.default.div.withConfig({
  displayName: "Progress__ProgressMeter",
  componentId: "o1pri3-2"
})(["background-color:", ";border-radius:inherit;height:100%;width:", ";"], (_ref2) => {
  var {
    theme
  } = _ref2;
  return theme.color.elementPrimary();
}, (_ref3) => {
  var {
    fraction
  } = _ref3;
  return "".concat(Math.round(fraction * 100), "%");
});

var ProgressLabel = (0, _styledComponents.default)(_Typography.Typography).attrs({
  variant: 'chip-tag-text'
}).withConfig({
  displayName: "Progress__ProgressLabel",
  componentId: "o1pri3-3"
})(["padding:0 ", ";color:", ";"], _designparams.spacing.medium, (_ref4) => {
  var {
    theme
  } = _ref4;
  return theme.color.text03();
});

var Progress = (_ref5) => {
  var {
    value,
    label
  } = _ref5,
      props = _objectWithoutProperties(_ref5, ["value", "label"]);

  return /*#__PURE__*/_react.default.createElement(ProgressContainer, props, /*#__PURE__*/_react.default.createElement(ProgressIndicator, null, /*#__PURE__*/_react.default.createElement(ProgressMeter, {
    fraction: value
  })), /*#__PURE__*/_react.default.createElement(ProgressLabel, null, label));
};

exports.Progress = Progress;