"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TickLabel = exports.TickMarker = exports.TickLabelContainer = void 0;

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _designparams = require("../designparams");

var _Typography = require("../Typography");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var BoxHalo = _styledComponents.default.div.attrs((_ref) => {
  var {
    width
  } = _ref;
  return {
    style: {
      width: "calc(".concat(width, "px + ").concat(_designparams.spacing.large, ")")
    }
  };
}).withConfig({
  displayName: "Tick__BoxHalo",
  componentId: "sc-12adr9s-0"
})(["position:absolute;transform:scaleX(0);height:-webkit-fill-available;border-radius:", ";transition:transform 100ms;pointer-events:none;"], _designparams.shape.radius.small);

var BaseTick = _styledComponents.default.div.attrs((_ref2) => {
  var {
    center
  } = _ref2;
  return {
    style: {
      left: "".concat(center, "%")
    }
  };
}).withConfig({
  displayName: "Tick__BaseTick",
  componentId: "sc-12adr9s-1"
})(["position:absolute;bottom:0px;background-color:", ";width:2px;height:2px;border-radius:50%;"], (_ref3) => {
  var {
    theme
  } = _ref3;
  return theme.color.text00();
});

var TickLabelContainer = _styledComponents.default.div.withConfig({
  displayName: "Tick__TickLabelContainer",
  componentId: "sc-12adr9s-2"
})(["position:relative;height:16px;width:", ";left:8px;"], "calc(100% - ".concat(parseInt(_designparams.spacing.large), "px)"));

exports.TickLabelContainer = TickLabelContainer;

var LabelContainer = _styledComponents.default.a.withConfig({
  displayName: "Tick__LabelContainer",
  componentId: "sc-12adr9s-3"
})(["display:inline-flex;align-items:center;justify-content:center;"]);

var BaseLabel = _styledComponents.default.div.attrs((_ref4) => {
  var {
    center,
    width
  } = _ref4;
  return {
    style: {
      left: "calc(".concat(center, "% - ").concat(width / 2, "px)")
    }
  };
}).withConfig({
  displayName: "Tick__BaseLabel",
  componentId: "sc-12adr9s-4"
})(["position:absolute;cursor:pointer;&:hover ", "{background-color:", ";transform:scaleX(1);}"], BoxHalo, (_ref5) => {
  var {
    theme
  } = _ref5;
  return theme.color.element11(_designparams.opacity[24]);
});

var TickMarker = (_ref6) => {
  var {
    position,
    marker
  } = _ref6;
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, marker === true ? /*#__PURE__*/_react.default.createElement(BaseTick, {
    center: position
  }) : null);
};

exports.TickMarker = TickMarker;

var TickLabel = (_ref7) => {
  var {
    position,
    label,
    value,
    handleChange
  } = _ref7;
  var [width, setWidth] = (0, _react.useState)(0);
  var el = (0, _react.useRef)(null);
  var handleClick = (0, _react.useCallback)(event => {
    event.stopPropagation();
    handleChange(value);
  }, [handleChange, value]);
  (0, _react.useLayoutEffect)(() => {
    if (el.current === null) {
      return;
    }

    setWidth(el.current.clientWidth);
  }, []);
  return /*#__PURE__*/_react.default.createElement(BaseLabel, {
    ref: el,
    center: position,
    width: width
  }, /*#__PURE__*/_react.default.createElement(LabelContainer, {
    onClick: handleClick
  }, /*#__PURE__*/_react.default.createElement(BoxHalo, {
    width: width
  }), /*#__PURE__*/_react.default.createElement(_Typography.Typography, {
    variant: "explanatory-text"
  }, label === undefined ? value : label)));
};

exports.TickLabel = TickLabel;