import React from 'react';
declare type BaseElement = HTMLDivElement;
declare type BaseProps = React.HTMLAttributes<BaseElement>;
declare type SpinnerType = 'primary' | 'dashed';
interface SpinnerProps extends BaseProps {
    /**
     * `class` to be passed to the component.
     */
    readonly className?: BaseProps['className'];
    /**
     * Used to choose spinner type.
     */
    readonly type?: SpinnerType;
    /**
     * Changes the label attatched to the spinner.
     */
    readonly label?: string;
}
export declare const Spinner: React.FC<SpinnerProps>;
export {};
