"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SkeletonTableRows = void 0;

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _designparams = require("../designparams");

var _Table = require("./Table");

var _context = require("./context");

var _TableCells = require("./TableCells");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

/**
 * Skeleton rows (used as a loading indicator)
 */
var pulse = (0, _styledComponents.keyframes)(["from{opacity:1;}to{opacity:", ";}"], _designparams.opacity[48]); // hard-coded size for a checkbox skeleton

var SkeletonCheckboxContent = _styledComponents.default.div.withConfig({
  displayName: "SkeletonRows__SkeletonCheckboxContent",
  componentId: "sc-1qv1rzz-0"
})(["border:2px;width:18px;height:18px;"]); // generic skeleton to replace text


var SkeletonContent = _styledComponents.default.div.withConfig({
  displayName: "SkeletonRows__SkeletonContent",
  componentId: "sc-1qv1rzz-1"
})(["width:100%;height:", ";"], _designparams.spacing.large);

var SkeletonRowGrid = _styledComponents.default.div.withConfig({
  displayName: "SkeletonRows__SkeletonRowGrid",
  componentId: "sc-1qv1rzz-2"
})(["z-index:0;display:grid;position:relative;grid-template-rows:", ";outline:none;pointer-events:none;& ", ",& ", "{animation:", " 800ms infinite ease-in-out alternate;}&:nth-child(odd) ", ",&:nth-child(odd) ", "{background-color:", ";}&:nth-child(even) ", ",&:nth-child(even) ", "{background-color:", ";}"], _designparams.componentSize.extraLarge,
/*sc-selector*/
SkeletonContent,
/*sc-selector*/
SkeletonCheckboxContent, pulse,
/*sc-selector*/
SkeletonContent,
/*sc-selector*/
SkeletonCheckboxContent, (_ref) => {
  var {
    theme
  } = _ref;
  return theme.color.background01();
},
/*sc-selector*/
SkeletonContent,
/*sc-selector*/
SkeletonCheckboxContent, (_ref2) => {
  var {
    theme
  } = _ref2;
  return theme.color.background02();
});

var SkeletonRow = /*#__PURE__*/_react.default.memo((_ref3) => {
  var {
    columns,
    gridTemplateColumns,
    hasCheckbox
  } = _ref3;
  var columnArray = Array.from(new Array(columns));
  return /*#__PURE__*/_react.default.createElement(SkeletonRowGrid, {
    style: {
      gridTemplateColumns
    }
  }, hasCheckbox ? /*#__PURE__*/_react.default.createElement(_TableCells.TableCellCheckbox, null, /*#__PURE__*/_react.default.createElement(SkeletonCheckboxContent, null)) : null, columnArray.map((__, index) => /*#__PURE__*/_react.default.createElement(_TableCells.TableCellContent, {
    key: index
  }, /*#__PURE__*/_react.default.createElement(SkeletonContent, null))));
});

SkeletonRow.displayName = 'SkeletonRowComponent';

var SkeletonTableRows = /*#__PURE__*/_react.default.memo((_ref4) => {
  var {
    rows,
    columns
  } = _ref4,
      props = _objectWithoutProperties(_ref4, ["rows", "columns"]);

  var rowArray = Array.from(new Array(rows));
  var {
    onSelect
  } = (0, _react.useContext)(_context.TableContext);
  var {
    gridTemplateColumns
  } = (0, _Table.useGridTemplateColumns)();
  return /*#__PURE__*/_react.default.createElement("div", _extends({
    style: {
      gridTemplateColumns
    }
  }, props), rowArray.map((_, i) => /*#__PURE__*/_react.default.createElement(SkeletonRow, {
    key: i,
    columns: columns,
    gridTemplateColumns: gridTemplateColumns,
    hasCheckbox: onSelect !== undefined
  })));
});

exports.SkeletonTableRows = SkeletonTableRows;
SkeletonTableRows.displayName = 'SkeletonTableRowsComponent';