"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.OverlayContainer = exports.TableHeaderText = exports.TableHeaderCellMenu = exports.TableHeaderCellCheckbox = exports.TableHeaderCellContent = exports.TableHeaderCell = exports.TableCellMenu = exports.TableCellCheckbox = exports.TableCellContent = exports.TableCell = void 0;

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _designparams = require("../designparams");

var _GlobalScrollbarStyle = require("../Global/GlobalScrollbarStyle");

var _Typography = require("../Typography");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
 * TableCell
 *
 * A regular cell in the table.
 */
var TableCell = _styledComponents.default.div.withConfig({
  displayName: "TableCells__TableCell",
  componentId: "sc-19yacsv-0"
})(["position:relative;display:flex;align-items:center;justify-content:left;box-sizing:border-box;height:100%;width:100%;white-space:nowrap;overflow:hidden;text-overflow:ellipsis;"]);

exports.TableCell = TableCell;
var TableCellContent = (0, _styledComponents.default)(TableCell).withConfig({
  displayName: "TableCells__TableCellContent",
  componentId: "sc-19yacsv-1"
})(["padding-right:", ";&:first-child{grid-column:content-start;}"], _designparams.spacing.extraLarge);
exports.TableCellContent = TableCellContent;
var TableCellCheckbox = (0, _styledComponents.default)(TableCell).withConfig({
  displayName: "TableCells__TableCellCheckbox",
  componentId: "sc-19yacsv-2"
})(["padding-right:", ";justify-content:center;grid-column:start;overflow:visible;"], _designparams.spacing.extraLarge);
exports.TableCellCheckbox = TableCellCheckbox;
var TableCellMenu = (0, _styledComponents.default)(TableCell).withConfig({
  displayName: "TableCells__TableCellMenu",
  componentId: "sc-19yacsv-3"
})(["padding-right:", "px;justify-content:flex-end;grid-column:content-end;overflow:visible;"], 20 - _GlobalScrollbarStyle.SCROLLBAR_DIMENSION);
/*
 * TableHeaderCell
 *
 * A header cell in the table.
 */

exports.TableCellMenu = TableCellMenu;
var TableHeaderCell = (0, _styledComponents.default)(TableCell).withConfig({
  displayName: "TableCells__TableHeaderCell",
  componentId: "sc-19yacsv-4"
})(["color:", ";background:", ";text-align:left;font-weight:", ";user-select:none;&:not:last-child{resize:horizontal;}"], (_ref) => {
  var {
    theme
  } = _ref;
  return theme.color.text02();
}, (_ref2) => {
  var {
    theme
  } = _ref2;
  return theme.color.background00();
}, (_ref3) => {
  var {
    theme
  } = _ref3;
  return theme.font.fontWeight.normal;
});
exports.TableHeaderCell = TableHeaderCell;
var TableHeaderCellContent = (0, _styledComponents.default)(TableHeaderCell).withConfig({
  displayName: "TableCells__TableHeaderCellContent",
  componentId: "sc-19yacsv-5"
})(["padding-right:", ";&:first-child{grid-column:content-start;}"], _designparams.spacing.large);
exports.TableHeaderCellContent = TableHeaderCellContent;
var TableHeaderCellCheckbox = (0, _styledComponents.default)(TableHeaderCell).withConfig({
  displayName: "TableCells__TableHeaderCellCheckbox",
  componentId: "sc-19yacsv-6"
})(["padding-right:", ";grid-column:start;justify-content:center;overflow:visible;"], _designparams.spacing.extraLarge);
exports.TableHeaderCellCheckbox = TableHeaderCellCheckbox;
var TableHeaderCellMenu = (0, _styledComponents.default)(TableHeaderCell).withConfig({
  displayName: "TableCells__TableHeaderCellMenu",
  componentId: "sc-19yacsv-7"
})(["padding-right:", "px;grid-column:content-end;justify-content:center;overflow:visible;"], 20 - _GlobalScrollbarStyle.SCROLLBAR_DIMENSION);
exports.TableHeaderCellMenu = TableHeaderCellMenu;
var TableHeaderText = (0, _styledComponents.default)(_Typography.Typography).attrs({
  variant: 'column-heading'
}).withConfig({
  displayName: "TableCells__TableHeaderText",
  componentId: "sc-19yacsv-8"
})(["text-transform:", ";"], (_ref4) => {
  var {
    theme
  } = _ref4;
  return theme.font.tableHeader.textTransform;
});
/**
 * A special long cell that overlays the entire header
 */

exports.TableHeaderText = TableHeaderText;
var OverlayContainer = (0, _styledComponents.default)(TableCell).withConfig({
  displayName: "TableCells__OverlayContainer",
  componentId: "sc-19yacsv-9"
})(["z-index:1;grid-column-start:content-start;grid-column-end:end;color:", ";"], (_ref5) => {
  var {
    theme
  } = _ref5;
  return theme.color.textPrimary();
});
exports.OverlayContainer = OverlayContainer;