"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ToastsAnchor = exports.ToastTransition = exports.ToastsProvider = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactTransitionGroup = require("react-transition-group");

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _designparams = require("../designparams");

var _Toast = require("./Toast");

var _toastReducer = require("./toastReducer");

var _useToasts = require("./useToasts");

var _context = require("./context");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var ToastsWrapper = _styledComponents.default.div.withConfig({
  displayName: "ToastsProvider__ToastsWrapper",
  componentId: "sc-1k3r8k9-0"
})(["position:fixed;top:", ";width:360px;border-radius:", ";margin:", " ", ";", ""], (_ref) => {
  var {
    top
  } = _ref;
  return top;
}, _designparams.shape.radius.medium, _designparams.spacing.medium, _designparams.spacing.large, (_ref2) => {
  var {
    justify
  } = _ref2;
  return justify === 'center' ? (0, _styledComponents.css)(["left:50%;transform:translateX(-50%);"]) : (0, _styledComponents.css)(["right:0;"]);
});
/**
 *
 * Toasts provider
 *
 * Used to provide a context for dispatching toast actions.
 *
 * Note: Do not use this directly! Instead use the `useToasts` hook which wraps
 * the dispatch ref.
 *
 */


var ToastsProvider = (_ref3) => {
  var {
    children
  } = _ref3,
      toastsOptions = _objectWithoutProperties(_ref3, ["children"]);

  var __dispatchRef = (0, _react.useRef)(_context.NI);

  var callbacks = (0, _useToasts.useToastCallbacks)(__dispatchRef, toastsOptions);
  return /*#__PURE__*/_react.default.createElement(_context.ToastsContext.Provider, {
    value: _objectSpread(_objectSpread({}, callbacks), {}, {
      __dispatchRef
    })
  }, children);
};

exports.ToastsProvider = ToastsProvider;

var ToastTransition = (_ref4) => {
  var {
    children
  } = _ref4,
      props = _objectWithoutProperties(_ref4, ["children"]);

  var ref = (0, _react.useRef)(null);
  return /*#__PURE__*/_react.default.createElement(_reactTransitionGroup.CSSTransition, _extends({
    nodeRef: ref,
    classNames: "practical",
    appear: true,
    timeout: 400,
    mountOnEnter: true,
    unmountOnExit: true
  }, props), /*#__PURE__*/_react.default.isValidElement(children) ? /*#__PURE__*/_react.default.cloneElement(children, {
    ref
  }) : null);
};

exports.ToastTransition = ToastTransition;

var ToastsAnchor = (_ref5) => {
  var {
    placement
  } = _ref5;
  var [toasts, dispatch] = (0, _react.useReducer)(_toastReducer.toastReducer, new Map());
  var {
    hideToast,
    __dispatchRef
  } = (0, _react.useContext)(_context.ToastsContext);
  __dispatchRef.current = dispatch;
  return /*#__PURE__*/_react.default.createElement(ToastsWrapper, placement, /*#__PURE__*/_react.default.createElement(_reactTransitionGroup.TransitionGroup, {
    component: null
  }, [...toasts.entries()].map((_ref6, index) => {
    var [id, props] = _ref6;
    return /*#__PURE__*/_react.default.createElement(ToastTransition, {
      key: id
    }, /*#__PURE__*/_react.default.createElement(_Toast.BaseToast, _extends({
      key: id,
      toastId: id,
      zIndex: -index,
      dismissToast: hideToast
    }, props)));
  })));
};

exports.ToastsAnchor = ToastsAnchor;